#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_hist_extract.pl
# !*-------------------------------------------------------------------------

$| = 1;
chop($P = `basename $0`); 
require "cgi_handlers.pl";

$maxrows       = 1000;

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

use DBI;
require "cgi_handlers.pl";

# General parms required
##$DBdir         = "/var/opt/apache/htdocs/cftasks";
##$modlockfile   = "$DBdir/modlock";
##$entlockfile   = "$DBdir/entlock";
##$conlockfile   = "$DBdir/conlock";
##$modfile       = "$DBdir/modEntries";
##$cfteamFile    = "$DBdir/cfteam";
##$entityFile    = "$DBdir/entities";

chop($date     = `date`);
chop($host     = `hostname`);
# Save Company name
$compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`;
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];

$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "<br><font size=2>$date ${P} | <b>$msgmsg</b>\n";
}

#-----------------------------------------------------------------------------
sub displayError 
#-----------------------------------------------------------------------------
{
   local($errorMsg) = @_;

   print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body><font face=$font>";

   print "<h2> The following database error occured - $date</h2>";
   print "<hr noshade>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   $sqlerror = $DBI::errstr;
   print "<br>SQL statement: $statement";
   print "<br>SQL error: $sqlerror";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub connectDBOld
#-----------------------------------------------------------------------------
{
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &displayError('Failed_on_DB_connect_in_updateDb');
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  $s_time = time;

  if ($this_sev ne "")
  {
    $where2 = "and sev = \'$this_sev\' ";
    $where3 = "";
  }
  else
  {
    $where2 = "";
    $where3 = "and ts >= sysdate - 183";
  }

  # Create the SQL SELECT statement
  $statement  = "
    select 
      to_char(ts,'YYYY/MM/DD-HH24:MI:SS'), 
      instance, 
      system, 
      sev, 
      text,
      paged,
      ticket
    from 
      events 
    where 
      instance = '$instance' 
      $where2
      and ts >= sysdate - 183
    order by ts desc
  ";
  ##print "SQL=$statement\n";

  &msg("Querying DBAMON.EVENTS data for this instance for the last six months");
  &msg("WHERE Clause: instance = '$instance' $where2 $where3");

  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $e_time = time;
  $elapsed = $e_time - $s_time;

  &msg("Query elapsed time: $elapsed seconds");

  print "<p><table border=3 width=80% >\n";
  print "<tr bgcolor=slate>
    <th><h5>Timestamp
    <th><h5>Ticket
    <th><h5>Event Text
    <th><h5>Instance
    <th><h5>Server
    <th><h5>Sev
    <th><h5>Paged?
  \n";

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $ts    = $Data[0];
    $in    = $Data[1];
    $sy    = $Data[2];
    $sev   = $Data[3];
    $text  = $Data[4];
    $paged = $Data[5];
    $ticket= $Data[6];

    $color = "white";
    if ($sev eq "C") { $color = "pink";   $fcolor = "black"}
    if ($sev eq "W") { $color = "yellow"; $fcolor = "black"}
    if ($sev eq "I") { $color = "cyan";   $fcolor = "black" }
    if ($sev eq "U") { $color = "lime";   $fcolor = "black"}
    if ($sev eq "S") { $color = "mediumpurple";  $fcolor = "black"}
    if ($sev eq "P") { $color = "lightskyblue";  $fcolor = "black"}

    if ($company eq "thecompany" && length($ticket) > 1) 
    {
      $ticket_url = "<b><a href='blt_lookup.pl?$ticket'>$ticket</a>";
    }
    else
    {
      $ticket_url = $ticket;
    }

    $fs = "2 face=$font";

    print "<tr bgcolor=$color>
      <td nowrap><font size=$fs color=$fcolor>$ts</font>
      <td nowrap><font size=$fs color=$fcolor><b>$ticket_url</font>
      <td nowrap><b><font size=$fs color=$fcolor>$text</font>
      <td><font size=$fs color=$fcolor>$in</font>
      <td><font size=$fs color=$fcolor>$sy</font>
      <td><font size=$fs color=$fcolor>$sev</font></font>
      <td><font size=$fs color=$fcolor>$paged</font></font>\n";

    if (++$selectcount > $maxrows) 
    { 
      print "<tr bgcolor=pink><td colspan=99><b><font size=2>MaxRows threshold of $maxrows exceeded\n";
      print "</table>\n";
      return; 
    }
  }

  if ($selectcount == 0) 
  { 
    print "<tr bgcolor=white><td colspan=5><b>No event history data found for instance: $instance\n";
  }
  print "</table>\n";
  &msg("Rows Selected: $selectcount");
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
   local($Signal) = @_;
   print "Signal=$Signal\n";
   exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str2="";
   $str4=" <h2>Insufficient or missing information...</h2>";
   $html_str=$str.$str1.$str2.$str1.$str4;
   print "$html_str\n";
   #print "<h2>Insufficient or missing information...";
   print "<br>\n";
   print "Please correct the following:</h2>";
   print "<p>\n";
   print "<hr><ul>\n";
   foreach( @error_list) {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   print "<hr>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors corrections to make.<p>\n";
   }
      
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{

   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

$logfile = "/tmp/dbamon_hist.log";
unlink($logfile);
chop($CurrentDate = `date`);

&get_request;

@words = split(/,/,$ARGV[0]);
$instance = $words[0];
$prodtest = $words[1];
$this_sev = $words[2];

if ($prodtest eq "test")
{
  $db = "dbamon_test";
}
else
{
  $db = "dbamon";
}

open(LOG, ">>$logfile" );
print LOG "$CurrentDate - $P dbms=$dbms prodtest=$prodtest\n";

print "Content-type: text/html\n\n
  <title>DBAmon Event History</title>
  <body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
  <table width=750><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=750>
  <tr bgcolor=wheat><td><font face=$font size=5>
      <center>Event History - Instance: $instance</center>
  </table>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "
</table>
<table width=750>

 $links_include

</table><hr>
";

# Print menu
print "
<table bgcolor=black width=750>
<tr align=center>
  <td><font size=2><font color=white> Re-Invoke: </font>
    <a href='/cgi-bin/dbamon_hist.pl?$instance,$prodtest,C'><font color=red   ><b>Critical Events Only</b></font></a> 
    <a href='/cgi-bin/dbamon_hist.pl?$instance,$prodtest,W'><font color=yellow><b>Warning Events Only</b></font></a> 
    <a href='/cgi-bin/dbamon_hist.pl?$instance,$prodtest,I'><font color=cyan  ><b>Info Events Only</b></font></a> 
    <a href='/cgi-bin/dbamon_hist.pl?$instance,$prodtest,U'><font color=green ><b>User Events Only</b></font></a> 
</table>
";

&msg("Starting - maxrows=$maxrows this_sev=$this_sev");

# Connect to DB
&connectDB;

# Connect to DB
&selectData;

&msg("Done");
close(LOG);
exit 0;
